package part1

import (
	"testing"
)

func TestPart1_Run(t *testing.T) {
	var inputs = []string{
		"Tile 2311:",
		"..##.#..#.",
		"##..#.....",
		"#...##..#.",
		"####.#...#",
		"##.##.###.",
		"##...#.###",
		".#.#.#..##",
		"..#....#..",
		"###...#.#.",
		"..###..###",
		"",
		"Tile 1951:",
		"#.##...##.",
		"#.####...#",
		".....#..##",
		"#...######",
		".##.#....#",
		".###.#####",
		"###.##.##.",
		".###....#.",
		"..#.#..#.#",
		"#...##.#..",
		"",
		"Tile 1171:",
		"####...##.",
		"#..##.#..#",
		"##.#..#.#.",
		".###.####.",
		"..###.####",
		".##....##.",
		".#...####.",
		"#.##.####.",
		"####..#...",
		".....##...",
		"",
		"Tile 1427:",
		"###.##.#..",
		".#..#.##..",
		".#.##.#..#",
		"#.#.#.##.#",
		"....#...##",
		"...##..##.",
		"...#.#####",
		".#.####.#.",
		"..#..###.#",
		"..##.#..#.",
		"",
		"Tile 1489:",
		"##.#.#....",
		"..##...#..",
		".##..##...",
		"..#...#...",
		"#####...#.",
		"#..#.#.#.#",
		"...#.#.#..",
		"##.#...##.",
		"..##.##.##",
		"###.##.#..",
		"",
		"Tile 2473:",
		"#....####.",
		"#..#.##...",
		"#.##..#...",
		"######.#.#",
		".#...#.#.#",
		".#########",
		".###.#..#.",
		"########.#",
		"##...##.#.",
		"..###.#.#.",
		"",
		"Tile 2971:",
		"..#.#....#",
		"#...###...",
		"#.#.###...",
		"##.##..#..",
		".#####..##",
		".#..####.#",
		"#..#.#..#.",
		"..####.###",
		"..#.#.###.",
		"...#.#.#.#",
		"",
		"Tile 2729:",
		"...#.#.#.#",
		"####.#....",
		"..#.#.....",
		"....#..#.#",
		".##..##.#.",
		".#.####...",
		"####.#.#..",
		"##.####...",
		"##..#.##..",
		"#.##...##.",
		"",
		"Tile 3079:",
		"#.#.#####.",
		".#..######",
		"..#.......",
		"######....",
		"####.#..#.",
		".#...#.##.",
		"#.#####.##",
		"..#.###...",
		"..#.......",
		"..#.###...",
	}
	expected := 20899048083289
	part1 := Part1{}
	actual, err := part1.Run(inputs)
	if err != nil {
		if err.Error() == "challenge not yet implemented" {
			t.Skip("challenge not yet implemented")
		}
		t.Error(err)
	}
	if actual != expected {
		t.Fatalf("expected: %d, actual: %d", expected, actual)
	}
}
